
public class SampleCallers
{

Subscriber one;
Subscriber two;

   public SampleCallers()
   {

      one = new Subscriber( "Jasper" );
      two = new Subscriber( "EeTee" );
   }

   private Subscriber findSubscriber( String name )
   {
      if ( name.equalsIgnoreCase( "Jasper" ) )
      {
         return one;
      }
      else if ( name.equalsIgnoreCase( "EeTee" ) )
      {
         return two;
      }  
      else
      {
         return null;
      }
   }

   public boolean call( String name, int minutes )
   {
      Subscriber temp = findSubscriber( name );
      if ( temp == null )
      {
         return false;
      }
      else
      {
         temp.makeCall( minutes );
         return true;
      }
   }

   public boolean sendText( String name )
   {
      Subscriber temp = findSubscriber( name );
      if ( temp == null )
      {
         return false;
      }
      else
      {
         temp.sendText();
         return true;
      }
   }

   public boolean pay( String name, int pesos )
   {
      Subscriber temp = findSubscriber( name );
      if ( temp == null )
      {
         return false;
      }
      else
      {
         temp.pay( pesos );
         return true;
      }
   }

   public void showAllSubscribers()
   {
      System.out.println( "Jasper balance due:   " + one.getBalance() );
      System.out.println( "Jasper total minutes: " + one.getMinutes() );
      System.out.println( "EeTee balance due:    " + two.getBalance() );
      System.out.println( "EeTee total minutes:  " + two.getMinutes() );
   }
   
   public void execute()
   {
      one.makeCall( 30 );
      two.makeCall ( 100 );
      one.pay( 200 );
      System.out.println( "Jasper balance due:   " + one.getBalance() );
      System.out.println( "EeTee balance due:    " + two.getBalance() );
      one.sendText();
      two.sendText();
      two.makeCall ( 30 ); // this will not be allowed
      two.pay( 500 );
      two.makeCall ( 30 ); // this will be allowed
      one.makeCall( 20 );
      two.sendText();
      this.showAllSubscribers();
   }

}
